<?php
class Griffin
{
	var $hostname;
	var $username;
	var $slow_query_function;
	var $slow_query_time;
	var $TerminateFunction;
	var $link_identifier;
	function Griffin()
	{
		$this->link_identifier = false;
		$this->slow_query_time = -1;
	}
	function SetHostname($hostname)
	{
		$this->hostname = $hostname;
		return $hostname;
	}
	function SetUsername($username)
	{
		$this->username = $username;
		return $username;
	}
	function SetTerminateFunction($functionname)
	{
		$this->TerminateFunction = $functionname;
		return $functionname;
	}
	function SetSlowQueryFunction($functionname)
	{
		$this->slow_query_function = $functionname;
		return $functionname;
	}
	function SetSlowQueryTime($time_in_s)
	{
		$this->slow_query_time = $time_in_s;
		return $time_in_s;
	}
	function Terminate($info)
	{
		if ($this->link_identifier === false) @call_user_func($this->TerminateFunction, $info);
		else
		{
			$info['mysql_errno'] = @mysql_errno($this->link_identifier);
			$info['mysql_error'] = @mysql_error($this->link_identifier);
			@call_user_func($this->TerminateFunction, $info);
		}
	}
	function CallSlowQueryFunction($info)
	{
		@call_user_func($this->slow_query_function, $info);
	}
	function Connect($password)
	{
		$this->link_identifier = @mysql_connect($this->hostname, $this->username, $password);
		if ($this->link_identifier === false)
		{
			$this->Terminate(array('griffin_reason' => 'MySQL connection could not be established', 'griffin_type' => 1));
			return false;
		}
		//connection was established
		return $this->link_identifier;
	}
	function q($query)
	{
		$start_time = $this->microtime_double();
		$result = @mysql_query($query, $this->link_identifier);
		$end_time = $this->microtime_double();
		if (($end_time - $start_time >= $this->slow_query_time) && ($this->slow_query_time !== -1)) $this->CallSlowQueryFunction(array('query' => $query, 'start_time' => $start_time, 'end_timer' => $end_time));
		if ($result === false)
		{
			$this->Terminate(array('griffin_reason' => 'mysql_query returned FALSE', 'query' => $query, 'griffin_type' => 2));
			return false;
		}
		//the query was successful
		return $result;
	}
	function SelectDatabase($database_name)
	{
		$result = @mysql_select_db($database_name, $this->link_identifier);
		if ($result === false)
		{
			$this->Terminate(array('griffin_reason' => 'mysql_select_db returned FALSE', 'database_name' => $database_name, 'griffin_type' => 3));
			return false;
		}
		//the selection was successful
		return $result;	//it returns true
	}
	function CloseConnection()
	{
		if ($this->link_identifier === false)
		{
			$this->Terminate(array('griffin_reason' => 'Cannot close connection - connection has not been established', 'griffin_type' => 4));
			return false;
		}
		//connection is established
		$result = @mysql_close($this->link_identifier);
		if ($result === false)
		{
			$this->Terminate(array('griffin_reason' => 'mysql_close returned FALSE', 'griffin_type' => 5));
			return false;
		}
		//the close was successful
		$this->link_identifier = false;
		return true;
	}
	function qtaa($query)
	{
		$result = $this->q($query);
		if ($result === false) return false;
		//query was successful. since $result must contain a resource, mysql_fetch_assoc should work 100%
		$result = @mysql_fetch_assoc($result);
		return $result;
	}
	function qtaas($query)
	{
		$result = $this->q($query);
		if ($result === false) return false;
		$na = array();
		while ($row = @mysql_fetch_assoc($result))
		{
			$na[] = $row;
		}
		return $na;	
	}
	function s($columns, $table, $post_conditions = '')
	{
		$query = 'SELECT ';
		$query .= $columns . ' ';
		$query .= 'FROM '. $table .' '. $post_conditions;
		$result = $this->q($query);
		if ($result === false) return false;
		//query was successful
		return $result;
	}
	function staas($columns, $table, $post_conditions = '')
	{
		$result = $this->s($columns, $table, $post_conditions);
		if ($result === false) return false;
		$na = array();
		while ($row = mysql_fetch_assoc($result)) {
			$na[] = $row;
		}
		return $na;
	}
	function staa($columns, $table, $post_conditions = '')
	{
		$result = $this->s($columns, $table, $post_conditions);
		if ($result === false) return false;
		$result = mysql_fetch_assoc($result);
		return $result;
	}
	function microtime_double()
	{
    	list($usec, $sec) = explode(" ", microtime());
    	return (double)((double)$usec + (integer)$sec);
	}
	function frfv($query)
	{
		$result = $this->q($query);
		if ($result === false) return false;
		$result = mysql_fetch_array($result, MYSQL_NUM);
		return $result[0];
	}
	function sfrfv($column, $table, $post_conditions = '')
	{
		$result = $this->staa($column, $table, $post_conditions);
		if ($result === false) return false;
		return $result[$column];
	}
	function sfrfvi($column, $table, $post_conditions = '')
	{
		$result = $this->sfrfv($column, $table, $post_conditions);
		if ($result === false) return false;
		return intval($result);
	}
	/**
	 * inserts the $data into the $table
	 * all the keys of $data should to be strings
	 * if a value of $data is of type string (is_string()), then "" will be used for the insert
	 * no data is escaped - not with addslashes or anything else
	 *
	 * @param array $data
	 * @param string $table
	 * @return false on failure, result of $this->q on success
	 */
	function i($data, $table)
	{
		$query = 'INSERT INTO '. $table .' ';
		$query .= 'SET ';
		$col_count = 0;
		foreach ($data as $col => $val) {
			if ($col_count > 0) $query .= ', ';
			if (is_integer($col)) {
				//we do not determine the variable type, the user took care of it all.
				$query .= $val;
			}
			elseif (is_string($val)) $query .= $col .' = "'. $val .'"';
			else $query .= $col .' = '. $val;
			++$col_count;
		}
		return $this->q($query);
	}
	function u($data, $table, $post_conditions = '')
	{
		$query = 'UPDATE '. $table .' ';
		$query .= 'SET ';
		$col_count = 0;
		foreach ($data as $col => $val) {
			if ($col_count > 0) $query .= ', ';
			if (is_integer($col)) {
				//we do not determine the variable type, the user took care of it all.
				$query .= $val;
			}
			elseif (is_string($val)) $query .= $col .' = "'. $val .'"';
			else $query .= $col .' = '. $val;
			++$col_count;
		}
		$query .= ' '. $post_conditions;
		return $this->q($query);
	}
	function d($table, $post_conditions = '')
	{
		$query = 'DELETE FROM '. $table .' '. $post_conditions;
		return $this->q($query);
	}
}

?>