<?php
/*
	Dependencies:
		class Cuscus
	Version:
		8 [2008-08-07 11:59]
*/
class Lama {
	/**
	 * obj of Cuscus
	 *
	 * @var Cuscus
	 */
	var $Cuscus;
	/**
	 * The name of teh function that will be called, if specified, with 1 argument - an array which contains the response from paypal and the name of the payment processor - "paypal"
	 * 
	 * By default, it's value is false -> no function is called
	 *
	 * @var bool/string
	 */
	var $awarder_function = false;
	/**
	 * The name of the table where Cuscus will insert logs of payments. Defaults to false - if set, willl be used. otherwise not.
	 *
	 * @var string
	 */
	var $payments_log_table;
	var $paypal_hostname;
	/**
	 * Logs the payment in the table $payments_log_table. DOES NOT PERFORM ANY CHECKS FOR THA VALIDITY OF THE PAYMENT. THIS HAS TO BE DETERMINED BY A SEPARATE SCRIPT.
	 *
	 * @param string $paypal_response
	 */
	function log_payment($paypal_response) {
		ob_start();
		var_dump($_POST);
		$all_data = ob_get_contents();
		ob_end_clean();
		
		$item_number = addslashes($this->get_variable('item_number'));
		$txn_type = addslashes($this->get_variable('txn_type'));
		$payment_status = addslashes($this->get_variable('payment_status'));
		$first_name = addslashes($this->get_variable('first_name'));
		$last_name = addslashes($this->get_variable('last_name'));
		$mc_fee = addslashes($this->get_variable('mc_fee'));
		$mc_currency = addslashes($this->get_variable('mc_currency'));
		$mc_gross = addslashes($this->get_variable('mc_gross'));
		$txn_id = addslashes($this->get_variable('txn_id'));
		$payment_date = addslashes($this->get_variable('payment_date'));
		$this->Cuscus->i($this->payments_log_table, array('all_data' => addslashes($all_data), 'item_number' => $item_number, 'txn_type' => $txn_type, 'payment_status' => $payment_status, 'first_name' => $first_name, 'last_name' => $last_name, 'mc_fee' => $mc_fee, 'mc_currency' => $mc_currency, 'mc_gross' => $mc_gross, 'txn_id' => $txn_id, 'payment_date' => $payment_date, 'paypal_response' => $paypal_response, 'adding_time' => addslashes(date('Y-m-d H:i:s'))));
	}
	function get_variable($name) {
		return (isset($_POST[$name]) ? $_POST[$name] : '');
	}
	/**
	 * This function will assume that Paypal started an IPN process and has posted some data to a certain script and now, this function has been called. It returns false when a HTTP error occurs, true otherwise
	 *
	 */
	function handle_payment() {
		$req = 'cmd=_notify-validate';
		foreach ($_POST as $key => $value) {
			$value = urlencode(stripslashes($value));
			$req .= "&$key=$value";
		}

		// post back to PayPal system to validate
		$header .= "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
		$fp = fsockopen ($this->paypal_hostname, 80, $errno, $errstr, 30);
		if (!$fp) {
			// HTTP ERROR
			return false;
		}
		else {
			fputs ($fp, $header . $req);
			while (!feof($fp)) {
				$res = fgets ($fp, 1024);
			}
			fclose($fp);
			if ($res === 'VERIFIED') {
				if ($this->payments_log_table !== false) $this->log_payment('VERIFIED');
			}
			elseif ($res === 'INVALID') {
				if ($this->payments_log_table !== false) {
					$this->log_payment('INVALID');
				}
			}
			if ($this->awarder_function !== false) call_user_func($this->awarder_function, array('paypal', array('res' => $res)));
			return true;
		}
	}
}

?>