<?php
class PurchaseValidator {
	public $cost;
	/**
	 * EUR or USD
	 *
	 * @var string
	 */
	public $currency_code;
	/**
	 * e-gold acc number or paypal email or alertpay email.
	 *
	 * @var string
	 */
	public $receiver = false;
	public $paypal_response = false;
	public $alertpay_securitycode = false;
	public $egold_alternate_password = false;
	function validate($method) {
		ob_start();
		var_dump($_POST); var_dump($_GET); var_dump($method);
		$d['alld'] = ob_get_contents();
		ob_end_clean();
		$d['tid'] = '';
		$d['gross'] = 0;
		$d['fee'] = 0;
		$d['cur'] = '';
		$d['receiver'] = '';
		
		if ($method === 'paypal') {
			$d['tid'] = gcpa('txn_id'); $d['gross'] = doubleval(gcpa('mc_gross')); $d['fee'] = doubleval(gcpa('mc_fee')); $d['cur'] = gcpa('mc_currency'); $d['receiver'] = gcpa('receiver_email');
		}
		elseif ($method === 'alertpay') {
			$d['tid'] = gcpa('ap_referencenumber'); $d['gross'] = doubleval(gcpa('ap_amount')); $d['fee'] = $d['gross']/100*2.5+0.25; $d['cur'] = gcpa('ap_currency'); $d['receiver'] = gcpa('ap_merchant');
		}
		elseif ($method === 'egold') {
			$d['tid'] = gcpa('PAYMENT_BATCH_NUM'); $d['gross'] = doubleval(gcpa('PAYMENT_AMOUNT')); $d['fee'] = doubleval(gcpa('FEEWEIGHT')) / (doubleval(gcpa('ACTUAL_PAYMENT_OUNCES')) + doubleval(gcpa('FEEWEIGHT')) ) * $d['gross']; $d['cur'] = $this->ceputcc(gcpa('PAYMENT_UNITS')); $d['receiver'] = gcpa('PAYEE_ACCOUNT');
		}
		
		//processor specific checks
		if ($method === 'paypal') {
			if ($this->paypal_response !== 'VERIFIED') return array($d, 2, 'paypal response !== "VERIFIED". Got: '. $this->paypal_response);
			elseif ($d['receiver'] !== $this->receiver) return array($d, 3, 'receiver: '.$d['receiver'].' expected: '.$this->receiver);
			elseif (gcpa('payment_status') !== 'Completed') return array($d, 5, 'payment status: '. gcpa('payment_status'));
		}
		elseif ($method === 'alertpay') {
			if (gcpa('ap_securitycode') !== $this->alertpay_securitycode) return array($d, 2, 'received code: '. gcpa('ap_securitycode').' expected: '. $this->alertpay_securitycode);
			elseif ($d['receiver'] !== $this->receiver) return array($d, 3, 'receiver: '.$d['receiver'].' expected: '.$this->receiver);
			elseif (gcpa('ap_purchasetype') === 'subscription') {
				if (gcpa('ap_status') !== 'Subscription-Payment-Success') {
					return array($d, 5, 'ap_purchasetype is subscription but ap_status: '. gcpa('ap_status'));
				}
			}
		}
		elseif ($method === 'egold') {
			if ($d['receiver'] !== $this->receiver) return array($d, 3, 'receiver: '. $d['receiver'].' expected: '. $this->receiver);
			$pieces = array ($_POST['PAYMENT_ID'], $_POST['PAYEE_ACCOUNT'], $_POST['PAYMENT_AMOUNT'], $_POST['PAYMENT_UNITS'], $_POST['PAYMENT_METAL_ID'],	$_POST['PAYMENT_BATCH_NUM'], $_POST['PAYER_ACCOUNT'], strtoupper(md5($this->egold_alternate_password)), $_POST['ACTUAL_PAYMENT_OUNCES'], $_POST['USD_PER_OUNCE'], $_POST['FEEWEIGHT'], $_POST['TIMESTAMPGMT']);
			$my_v2_hash = strtoupper(md5(implode(':', $pieces)));
			if ($my_v2_hash !== gcpa('V2_HASH')) return array($d, 2, 'invalid hash: '. $my_v2_hash .' expected: '. gcpa('V2_HASH'));
			if (gcpa('PAYMENT_METAL_ID') !== '1') return array($d, 10, 'PAYMENT_METAL_ID: '. gcpa('PAYMENT_METAL_ID'));
		}
		else return array($d, 9, 'method: '.$method);
		
		//general checks
		if (doubleval($this->cost) !== doubleval($d['gross'])) return array($d, 6, 'received amount: '. $d['gross'].' expected: '.$this->cost);
		elseif ($this->currency_code !== $d['cur']) return array($d, 7, 'received currency: '. $d['cur'].' expected: '.$this->currency_code);
		
		//no problems were encountered. a payment was actually received
		//add credits to user's account
		return array($d, 1, 'Success');
	}
	function ceputcc($pu) {
		if ($pu === '85') return 'EUR';
		if ($pu === '1') return 'USD';
		return '';
	}
}
?>